ASPGestionProduit/Models/Panier.cs
using Microsoft.AspNetCore.Mvc.Formatters;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ASPGestionProduit.Models
{
    public class Panier
    {
        private int id;
        private List<ProductPanier> productPaniers;
        private static int index;

        public int Id { get => id; set => id = value; }
        public List<ProductPanier> ProductPaniers { get => productPaniers; set => productPaniers = value; }


       public Panier()
        {
            Id = index++;

            ProductPaniers = new List<ProductPanier>();

        }



        public void AddProduct(Product product, int qty)
        {
            bool found = false;
            ProductPaniers.ForEach((p) =>
            {
                if (p.Product.Id == product.Id)
                {
                    p.Qty += qty;
                    found = true;
                }
            });
            if (!found)
            {
                ProductPanier productCart = new ProductPanier() { Product = product, Qty = qty };
                ProductPaniers.Add(productCart);
            }
        }



    }
}

ASPGestionProduit/Controllers/CommandeController.cs
using ASPGestionProduit.Interface;
using ASPGestionProduit.Models;
using ASPGestionProduit.Tools;
using ASPGestionProduit.ViewModel;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Security.Claims;
using System.Threading.Tasks;

namespace ASPGestionProduit.Controllers
{
    public class CommandeController : Controller
    {

        private IPanier _servicePanier;
        private IHttpContextAccessor _accessor;


        public CommandeController(IHttpContextAccessor accessor, IPanier servicePabier)
        {
            _servicePanier = servicePabier;
            _accessor = accessor;

        }

        public IActionResult ValidationCommande(int idPaiement)
        {

            string p = HttpContext.Session.GetString("seriePanier");
            int quantiteProductCommand = 0;
            DateTime date = DateTime.Now;
            Decimal totalTotal = 0;

            List<ProductCommande> productCommandes = new List<ProductCommande>();
            List<Product> products = new List<Product>();
            Panier panier = JsonConvert.DeserializeObject<Panier>(p);
            MoyenPaiement moyenPaiement = Sauvegarde.Instance.GetMoyenPaiementById(idPaiement);

            foreach (ProductPanier pP in panier.ProductPaniers)
            {

                decimal total = pP.Qty * pP.Product.Prix;

                totalTotal += total;
                Product product = Sauvegarde.Instance.GetProdutcById(pP.Product.Id);
                ProductCommande productCommande = new ProductCommande() { Product = product, Qte = pP.Qty };
                productCommandes.Add(productCommande);
            };




            string emailUser = HttpContext.User.Claims.FirstOrDefault(u => u.Type == ClaimTypes.Email).Value;

            Utilisateur utilisateur = DataContext.Instance.Utilisateurs.FirstOrDefault(u => u.Identifiant == emailUser);

            Commande commande = new Commande() { ProductCommande = productCommandes, Utilisateur = utilisateur, MoyenPaiement = moyenPaiement, Date = date };



            foreach (ProductCommande pp in commande.ProductCommande)
            {
                quantiteProductCommand += pp.Qte;
            }

            commande.Qte = quantiteProductCommand;
            commande.Montant = totalTotal;

            DataContext.Instance.Commandes.Add(commande);

            DataContext.Instance.SaveChanges();

            Etat etat = new Etat();

            List<Etat> etats = Sauvegarde.Instance.GetEtat();

            foreach(Etat e in etats)
            {
                if(e.Statut == "Validée")
                {
                    etat = e;


                }


            }

            EtatCommande etatcommande = new EtatCommande() { Commande = commande, Date = date, Etat = etat };
            DataContext.Instance.EtatCommandes.Add(etatcommande);
            DataContext.Instance.SaveChanges();

            HistoriqueEtatCommandes historiqueEtatCommandes = new HistoriqueEtatCommandes() { DateEtatCommande = date, EtatComande = etat.Statut, NumeroCommande = commande.Id, NomEmploye = commande.Utilisateur.Nom };
            DataContext.Instance.HistoriqueEtatCommandes.Add(historiqueEtatCommandes);
            DataContext.Instance.SaveChanges();


            HttpContext.Session.Clear();


            return View("ListCommande", commande);
        }


        public IActionResult MesCommandes()
        {

            string identifiant = _accessor.HttpContext.User.Claims.FirstOrDefault(x => x.Type == ClaimTypes.Email).Value;
            string name = _accessor.HttpContext.User.Claims.FirstOrDefault(x => x.Type == ClaimTypes.Name).Value;


            List<Commande> commandes = Sauvegarde.Instance.GetCommandesByUser(identifiant, name);

            return View("MesCommandes", commandes);
        }


        public IActionResult GestionCommande()
        {

            List<Etat> etats = Sauvegarde.Instance.GetEtat();

            ViewBag.etats = etats;

            return View();
        }


        public IActionResult DetailsCommande(int id, bool modifie)
        {
            CommandeViewModel vm = new CommandeViewModel();

            if(modifie != false)
            {
                modifie = true;
            }else
            {
                modifie = false;
            }



            ViewBag.modifie = modifie;

          List<Etat> etats = Sauvegarde.Instance.GetEtat();

          List<EtatCommande> listesEtatsCommandes = Sauvegarde.Instance.SearchCommandByEtatId(id);

            List<HistoriqueEtatCommandes> historiqueEtatCommandes = Sauvegarde.Instance.GetHistoriqueEtatCommandesByIdCommand(id);

            List<MessagesCommandes> messagesCommandes = Sauvegarde.Instance.GetListMessagesByIdCommande(id);

            Commande commande = Sauvegarde.Instance.GetCommandeByIdCommand(id);

            vm.EtatCommandes = listesEtatsCommandes;

            vm.Etatss = etats;

            vm.historiqueEtatCommandes = historiqueEtatCommandes;

            vm.commande = commande;

            vm.messagesCommandes = messagesCommandes;

           return View(vm);

        }
        public IActionResult RechercheCommande(string nom)
        {


            List<EtatCommande> etatCommandes = Sauvegarde.Instance.SearchCommandByEtat(nom);
                  List<Etat> etats = Sauvegarde.Instance.GetEtat();

            ViewBag.etats = etats;


            return View("GestionCommande", etatCommandes);

        }


        public IActionResult ModifieEtat(bool modifie, int id)
        {


           return  RedirectToAction("DetailsCommande", new { modifie = modifie, id = id });
        }



        public IActionResult ValidModifieEtat(bool modifie, int idEtat, int idEtatCommande)
        {
            DateTime date = DateTime.Now;

          string nom = @_accessor.HttpContext.User.Claims.FirstOrDefault(x => x.Type == ClaimTypes.Name).Value;

            EtatCommande etatCommande = Sauvegarde.Instance.GetEtatCommandeById(idEtatCommande);

            Etat etat = Sauvegarde.Instance.GetEtatById(idEtat);

            etatCommande.Date = date;
            etatCommande.Etat = etat;
            DataContext.Instance.SaveChanges();


            HistoriqueEtatCommandes historiqueEtatCommandes = new HistoriqueEtatCommandes() { DateEtatCommande = date, EtatComande = etat.Statut, NomEmploye = nom, NumeroCommande = etatCommande.Commande.Id };
            DataContext.Instance.HistoriqueEtatCommandes.Add(historiqueEtatCommandes);
            DataContext.Instance.SaveChanges();


            modifie = false;

            return RedirectToAction("DetailsCommande", new {modifie = modifie, id = etatCommande.Commande.Id });
        }

        public IActionResult ActionListCommande(string id)
        {


            List<EtatCommande> etatsCommandes = Sauvegarde.Instance.GetCommandeByEtat(id);

            List<Etat> etats = Sauvegarde.Instance.GetEtat();

            ViewBag.etats = etats;

            return View("GestionCommande", etatsCommandes);

        }


        public IActionResult CreateMessageCommande(int id, string message)
        {

            Commande commande = Sauvegarde.Instance.CommandeById(id);

            string email = @_accessor.HttpContext.User.Claims.FirstOrDefault(x => x.Type == ClaimTypes.Email).Value;

            DateTime date = DateTime.Now;

            Utilisateur utilisateur = Sauvegarde.Instance.GetUtilisateurByEmail(email);

            MessagesCommandes messagesCommandes = new MessagesCommandes() { Commande = commande, Utilisateur = utilisateur, Date = date, Message = message };

            DataContext.Instance.MessagesCommandes.Add(messagesCommandes);
            DataContext.Instance.SaveChanges();

            bool modifie = false;

            return RedirectToAction("DetailsCommande", new { modifie = modifie, id = id });

        }


        public IActionResult CreateMessageCommandeUser(int id, string message)
        {
            Commande commande = Sauvegarde.Instance.CommandeById(id);

            string email = @_accessor.HttpContext.User.Claims.FirstOrDefault(x => x.Type == ClaimTypes.Email).Value;

            DateTime date = DateTime.Now;

            Utilisateur utilisateur = Sauvegarde.Instance.GetUtilisateurByEmail(email);

            MessagesCommandes messagesCommandes = new MessagesCommandes() { Commande = commande, Utilisateur = utilisateur, Date = date, Message = message };

            DataContext.Instance.MessagesCommandes.Add(messagesCommandes);
            DataContext.Instance.SaveChanges();
            return RedirectToAction("DetailsCommandeUser", new { id = id });

        }


        public IActionResult HistoriqueCommandes()
        {
            

            return View();
        }


        public IActionResult GetHistoriqueCommandes(int id)
        {

            List<HistoriqueEtatCommandes> historiqueEtatCommandes = Sauvegarde.Instance.GetHistoriqueEtatCommandesByIdCommand(id);


            return View("HistoriqueCommandes",historiqueEtatCommandes );
        }


        public IActionResult DetailsCommandeUser(int id)
        {
            CommandeViewModel vm = new CommandeViewModel();

            List<Etat> etats = Sauvegarde.Instance.GetEtat();

            List<EtatCommande> listesEtatsCommandes = Sauvegarde.Instance.SearchCommandByEtatId(id);

            List<HistoriqueEtatCommandes> historiqueEtatCommandes = Sauvegarde.Instance.GetHistoriqueEtatCommandesByIdCommand(id);

            List<MessagesCommandes> messagesCommandes = Sauvegarde.Instance.GetListMessagesByIdCommande(id);


ASPGestionProduit/Controllers/PanierController.cs
using ASPGestionProduit.Interface;
using ASPGestionProduit.Models;
using ASPGestionProduit.Tools;

using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Security.Claims;

namespace ASPGestionProduit.Controllers
{
    public class PanierController : Controller
    {

        private IPanier _servicePanier;
        private IHttpContextAccessor _accessor;

        public PanierController(IPanier servicePabier, IHttpContextAccessor accessor)
        {
            _servicePanier = servicePabier;
            _accessor = accessor;

        }


       
        public IActionResult AffichePanier()
        {
            Panier panier = _servicePanier.GetPanier();
          
            return View(panier);


        }



        public IActionResult AddProduct(int id, int quantite)
        {


            Product product = Sauvegarde.Instance.GetProdutcById(id);
            bool trouve = false;
            Panier panier = _servicePanier.GetPanier();
          
            if (panier.ProductPaniers.Count != 0)
            {

                foreach (ProductPanier p in panier.ProductPaniers)
                {
                    if (product.Id == p.Product.Id)
                    {
                        p.Qty += quantite;
                        trouve = true;


                    }
                    else
                    {
                        trouve = false;
                    }
                }

                if (trouve == false)
                {

                    ProductPanier productPanier1 = new ProductPanier();
                    productPanier1.Product = product;
                    productPanier1.Qty = quantite;
                    _servicePanier.AddPanier(productPanier1, panier);
                }


                _servicePanier.UpdatePanier(panier);


                return RedirectToAction("AffichePanier");
            }
            else
            {
                panier = new Panier();

                ProductPanier productPanier2 = new ProductPanier();
                productPanier2.Product = product;
                productPanier2.Qty = quantite;

                _servicePanier.AddPanier(productPanier2, panier);

                return RedirectToAction("AffichePanier");



            }
        }



        public IActionResult ViderPanier()
        {

           if( _servicePanier.RemovePanier() == true)
            {
                return RedirectToAction("AffichePanier");
            }
            else
            {
                return RedirectToAction("AffichePanier");

            }

          
        }


        [Authorize(Policy = "connectOk")]
        public IActionResult etapeSuivante()
        {

            Panier panier = _servicePanier.GetPanier();
           
            if(panier.ProductPaniers.Count != 0) { 
                decimal totals = 0;
                foreach (ProductPanier p in panier.ProductPaniers)
                {
                    decimal total = p.Qty * p.Product.Prix;
                    totals += total;
                }

                ViewBag.total = totals;
            }
            else
            {
                panier = new Panier();
            }


            ViewBag.paiements = Sauvegarde.Instance.GetMoyenPaiements();
            return View("ValidationPanier", panier);




        }

    }

}

ASPGestionProduit/Views/Panier/AffichePanier.cshtml
@model Panier
<div class="container">
    <h5 class="m-3">Detail Panier</h5>
    @if (@Model.ProductPaniers.Count != 0)
    {
        <table class="table table-primary">
            <thead>
                <tr>

                    <th scope="col">Titre</th>
                    <th scope="col">Quantite</th>
                    <th scope="col">Prix</th>
                    <th scope="col">Total</th>
                    <th scope="col">infos</th>
                </tr>
            </thead>
            <tbody>

                @if (@Model.ProductPaniers.Count > 0)
                {
                    @foreach (ProductPanier p in @Model.ProductPaniers)
                    {

                        <tr>
                            <td>@p.Product.Titre</td>
                            <td>@p.Qty</td>
                            <td>@p.Product.Prix euros</td>
                            <td>@(@p.Product.Prix * @p.Qty) euros</td>
                            <td><a asp-controller="Panier" asp-action="DeleteProductPanier" asp-route-id="">Supprimer</a></td>
                        </tr>

                    }


                }
            </tbody>
            <tfoot>
                <tr>
                    <th>Total</th>
                    <td colspan="3"></td>
                    <td>
                        <span>
                            @if (ViewBag.total != null)
                            {<span>@ViewBag.total <span>euros</span></span>
                        }
                        else
                        {<div>0 euros</div>}
                        </span>
                    </td>
                </tr>
            </tfoot>
        </table>
        <div class="row">
            <div><a class="btn btn-primary mr-4" asp-controller="Panier" asp-action="etapeSuivante">Suivant</a></div>
            <div><a class="btn btn-warning" asp-controller="Panier" asp-action="ViderPanier">Vider Panier</a></div>
        </div>
       
    }
    else
    {
        <div class="row">
            <div class="col alert-danger alert">
                Le Panier est vide.
            </div>
        </div>

    }
</div>
  

ASPGestionProduit/Views/Panier/ListCommande.cshtml
@model Commande
<div class="container">
    <h5>Detail des Commandes</h5>
    <table class="table table-dark">
        <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Titre</th>
                <th scope="col">Quantite</th>
                <th scope="col">Acheteur</th>
                <th scope="col">infos</th>
            </tr>
        </thead>
        <tbody>
            @foreach (ProductCommande p in @Model.ProductCommande)
            {
                <tr>
                    <th scope="row">1</th>
                    <td>@p.Product.Titre</td>
                    <td>@p.Qte</td>
                    <td>@Model.Utilisateur.Nom</td>
                    <td><a asp-controller="Panier" asp-action="DeleteProductPanier" asp-route-id="@Model.Id">Suppimer</a></td>
                </tr>
            }
        </tbody>
        <tfoot>
        </tfoot>
    </table>
</div>

ASPGestionProduit/Views/Panier/MesCommandes.cshtml
@model List<Commande>
<div class="container">
    <h5>Detail des Commandes</h5>
    <table class="table table-dark">
        <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Nombre de Produit</th>
                <th scope="col">Quantite</th>
                <th scope="col">Date</th>
                <th scope="col">Montant</th>
                <th scope="col">Paiement</th>
                <th scope="col">infos</th>
            </tr>
        </thead>
        <tbody>
            @foreach (Commande c in @Model)
            {
                <tr>

                    <th scope="row">1</th>
                    <td>@c.ProductCommande.Count</td>
                    <td>@c.Qte</td>
                    <td>@c.Date</td>
                    <td>@c.Montant</td>
                    <td>
                        @c.MoyenPaiement.Moyen

                </td>
                <td><a asp-controller="Panier" asp-action="" asp-route-id="@c.Id">Details</a></td>
                
            </tr>
            }
        </tbody>
        <tfoot>
        </tfoot>
    </table>
</div>

ASPGestionProduit/Views/Panier/ValidationPanier.cshtml
@model Panier
<div class="container">
    <h5>Recapitulatif Panier</h5>
    <div class="card m-2">
        <div class="card-body">
            <h5 class="card-title">Liste des produits</h5>
            <table class="table">
                <thead>
                    <tr>
                     
                        <th scope="col">Nom</th>
                        <th scope="col">Qte</th>
                        <th scope="col">Prix</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (ProductPanier p in Model.ProductPaniers)
                    {
                        <tr>
                         
                            <td>@p.Product.Titre</td>
                            <td>@p.Qty</td>
                            <td>@p.Product.Prix euros</td>
                        </tr>
                    }
                </tbody>
            </table>
            <div class="row">
                <h6>Total :</h6> <div>
                    <span>
                        @if (ViewBag.total != null)
                        {<span>@ViewBag.total <span>euros</span></span>
                    }
                    else
                    {<div>0 euros</div>}
                    </span>
                </div>
            </div>

        </div>
    </div>
    <form enctype="multipart/form-data" asp-controller="Commande" asp-action="ValidationCommande">
        <div class="form-group">
            <label>Moyens de Paiement</label>
            <select class="form-control" name="idPaiement">
                @foreach (MoyenPaiement m in @ViewBag.paiements)
                {
                    <option value="@m.Id">@m.Moyen</option>
                }
            </select>
            <div><button class="btn btn-primary mt-4" type="submit">Valider la Commande</button></div>
            <div><a class="btn btn-warning" asp-controller="Panier" asp-action="ViderPanier">Vider Panier</a></div>
        </div>
    </form>